<?php
namespace FiloBlu\ScratchAndWin\Model\Config\Source;

class ScratchAndWin implements \Magento\Framework\Option\ArrayInterface
{

    protected $_collectionFactory;
    protected $_escaper;
    
    public function __construct(
        \FiloBlu\ScratchAndWin\Model\ResourceModel\ScratchAndWin\CollectionFactory $collectionFactory, 
        \Magento\Framework\Escaper $escaper
    ) {
        $this->_collectionFactory = $collectionFactory;
        $this->_escaper = $escaper;
    }
    
    /**
     * @return array
     */
    public function toOptionArray($default = false)
    {
        $collection = $this->_collectionFactory->create();
        $array = [];
        
        if ($default) {
            $array[] = [
                'label' => __('All ScratchAndWin'),
                'value' => 0
            ];
        }
        
        foreach ($collection as $scratchandwin) {
            $array[] = [
                'label' => $this->_escaper->escapeQuote($scratchandwin->getId() . ' - ' . $scratchandwin->getCode(), true),
                'value' => $scratchandwin->getCode()
            ];
        }
        
        return $array;
    }
    
}
