// This class is what handles the AJAX request on initialization 
// and sets the data in the DOM from the controller response.
define([
    'ko',
    'jquery',
    'matchMedia',
    'uiComponent',
    'FiloBlu_ScratchAndWin/js/model/current-date',
    'swiper_4_0_6',
    'FiloBlu_Design/js/widget/swiper'
], function(ko, $, mediaCheck, Component, modelDate, Swiper) {
    "use strict";

    return Component.extend({

        initialize: function() {

            var self = this;

            this._super();

            self.getDate = function() {
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    cache: true,
                    url: self.baseUrl + 'scratchandwin/get/date',
                    success: function(data) {
                        modelDate(data);
                    }
                });
            }

            mediaCheck({
                media: '(max-width: 991px)',
                entry: $.proxy(function() {
                    var container = $(self.scratchSwiperContainer);

                    window.scratchSlider = new Swiper(container, {
                        lazyLoading: false,
                        autoplay: false,
                        slidesPerView: 1.7,
                        loop: false,
                        speed: 800,
                        keyboardControl: true,
                        spaceBetween: 15,
                        grabCursor: false,
                        noSwiping: true,
                        centeredSlides: true,
                        navigation: {
                            prevEl: $('.swiper-pagination-container .swiper-button-prev', container),
                            nextEl: $('.swiper-pagination-container .swiper-button-next', container)
                        },
                        pagination: {
                            el: $('.swiper-pagination-container .swiper-pagination', container)
                        },
                        breakpoints: {
                            767: {
                                slidesPerView: 1.7,
                                spaceBetween: 15
                            },
                            991: {
                                slidesPerView: 4,
                                spaceBetween: 15
                            }
                        }
                    });

                }, this),

                exit: $.proxy(function() {
                    if (typeof window.scratchSlider != 'undefined') {
                        window.scratchSlider.destroy(false, true);
                    }
                }, this)
            });

            self.getDate();
        }

    });
});